<?php 
require_once 'class-extension-import.php';

class SrmehranApi extends SrmehranImporter{
	private $limitloader;
	static $objRecoder;
		public function __construct() {
		
		require_once 'class-limit-Bulider.php';
		require_once 'class-events-records.php';
			$this->limitloader= new Limits();
			self::$objRecoder = new RecoderApi();
		// Hook up our WordPress customizations.
		add_action( 'wp_ajax_get_import_SrmehranApi', array( $this, 'get_import_SrmehranApi' ) );
		add_action('wp_ajax_nopriv_get_import_SrmehranApi', array( $this, 'get_import_SrmehranApi' ));
		
		
		add_action( 'wp_ajax_get_import_templatess', array( $this, 'get_import_templatess' ) );
		add_action('wp_ajax_nopriv_get_import_templatess', array( $this, 'get_import_templatess' ));
		
		add_action( 'wp_ajax_get_import_free_Blocks', array( $this, 'get_import_free_Blocks' ) );
		add_action('wp_ajax_nopriv_get_import_free_Blocks', array( $this, 'get_import_free_Blocks' ));
		
		
		add_action( 'wp_ajax_load_ss_Template', array( $this, 'load_ss_Template' ) );
		add_action('wp_ajax_nopriv_load_ss_Template', array( $this, 'load_ss_Template' ));
		
		
		
		add_action( 'wp_ajax_load_ss_Template_ById', array( $this, 'load_ss_Template_ById' ) );
		add_action('wp_ajax_nopriv_load_ss_Template_ById', array( $this, 'load_ss_Template_ById' ));
		
		
		add_action( 'wp_ajax_load_ss_premiumkits', array( $this, 'load_ss_premiumkits' ) );
		add_action('wp_ajax_nopriv_load_ss_premiumkits', array( $this, 'load_ss_premiumkits' ));
		
		add_action( 'wp_ajax_load_ss_auth', array( $this, 'load_ss_auth' ) );
		add_action('wp_ajax_nopriv_load_ss_auth', array( $this, 'load_ss_auth' ));
		
		add_action( 'wp_ajax_load_ss_freekits', array( $this, 'load_ss_freekits' ) );
		add_action('wp_ajax_nopriv_load_ss_freekits', array( $this, 'load_ss_freekits' ));
		
		add_action( 'wp_ajax_load_ss_free_blocks', array( $this, 'load_ss_free_blocks' ) );
		add_action('wp_ajax_nopriv_load_ss_free_blocks', array( $this, 'load_ss_free_blocks' ));
		
	}
	
	
	public function load_ss_auth(){
		$info=SRMEHRAN_Templtes::$api_handel->sr_get_ss_user_info();
		if(!empty($info['username_ss'])&&!empty($info['password_ss'])){
				$result=[
					'status'=>true,
					'message'=>'loggedin',
				];
		}else{
			$result=[
					'status'=>false,
					'message'=>'falid',
				];
		}
		
		
		
		echo json_encode($result);
			die;
		
	}
	
	public function get_import_SrmehranApi(){
		
		$info=SRMEHRAN_Templtes::$api_handel->sr_get_ss_user_info();
		if($_POST['type']=='PremiumTemplate'||$_POST['type']=='Free_kits'){
			$this->limitloader->limitsBulider();
			$getprodcutbyId=[
			'action'=>'getprodcutbyId',
			'pid'=>$_POST['project_id'],
			'userId'=>$info['username_ss'],
			'type'=>$_POST['type']
			];
			
			$getprodcutbyIdHandel=SRMEHRAN_Templtes::$api_handel->mehran_request_ajax('https://srmehranclub.com/',$getprodcutbyId);
			$getprodcutbyIdHandel=json_decode($getprodcutbyIdHandel);
			
		
			
			if($getprodcutbyIdHandel->status=='success'){
				$data=$getprodcutbyIdHandel->data[0];
				// Download our remote ZIP file to a local temporary file:
				require_once( ABSPATH . '/wp-admin/includes/file.php' );
				$temporary_zip_path = wp_tempnam( 'ss-' .$_POST['button_id']);
				
			$dresponse  = wp_safe_remote_get($data->download_link, array(
				'timeout'  => 60,
				'stream'   => true,
				'filename' => $temporary_zip_path
			) );
			
			if ( is_wp_error( $dresponse ) ) {
				$result=[
					'status'=>'fail',
					'message'=>$dresponse->get_error_message(),
				];
			
			}
			///if file donaloder
			
			$rponse=parent::installPremiumKit($temporary_zip_path);
			unlink( $temporary_zip_path);
			if ( is_wp_error( $rponse ) ) {
				$result=[
					'status'=>'zip_failure',
					'message'=>$rponse->get_error_message(),
				];
			}
			
			$id=SRMEHRAN_Templtes::$template_ui->blocks_crypt( $rponse,'e');
			$result=[
					'status'=>'success',
					'data'=>$rponse,
					'inserted'=>'admin.php?page=srmehran-installed-kits&instkitId='.$id,
					'message'=>'successfully',
				];
				if($rponse){
				$ssrecord=[
					'type'=>$_POST['type'],
					'action'=>$_POST['action'],
					'template_id'=>$_POST['project_id'],
					'post_id'=>$rponse,
				];
				$rr=SrmehranApi::$objRecoder->recordSmrhanEvent($ssrecord);
				}
			}else{
				$result=[
					'status'=>'fail',
					'message'=>'0 record found',
				];
			}
			echo json_encode($result);
			die;
		}
		
	}
	
	/**
	 * Gets the local path for the extracted ZIP file on the hosting account.
	 * Used to get the path for JSON files so page builders can load them in.
	 *
	 * @return string
	 */
	public function get_template_kit_temporary_folder($template_kit_id) {
		$template_kit_folder_name = get_post_meta($template_kit_id, 'srmehranclub_ss_folder_name', true );
		$wp_upload_dir            = wp_upload_dir();
		$template_kit_folder_path = $wp_upload_dir['basedir'] . '/srmehranclub-ss/' . $template_kit_folder_name . '/';
		// Confirm we're pulling this data from the right location:
		if ( strpos( $template_kit_folder_path, $wp_upload_dir['basedir'] ) === 0 ) {
			return $template_kit_folder_path;
		}
		return null;
	}
	
	
	public function get_template_data_index($template_kit_id,$template_id){
		require_once('class-builder-loader.php');
		$obj_sclassBuilder=new sclassBuilder();
		$templates_ss=$obj_sclassBuilder->get_ssavailable_templates($template_kit_id);
		if ( isset( $templates_ss[ $template_id ] ) ) {
			return $templates_ss[ $template_id ];
		}
		return false;
		
	}
	
	public function get_template_data_ss($template_kit_id,$template_id){
		$template_data_getter=$this->get_template_data_index($template_kit_id,$template_id);
		if ( $template_data_getter && ! empty( $template_data_getter['source'] ) ) {
			 $template_kit_ss_folder_name   = $this->get_template_kit_temporary_folder($template_kit_id);
			return $template_ss_json_file   = $template_kit_ss_folder_name . $template_data_getter['source'];
			
			/*$template_ss_data['template_json'] = json_decode( file_get_contents( $template_ss_json_file ), true );
			return $template_ss_data;*/
			
		}
		return false;
	}

	public function get_import_templatess(){
		
		$template_kit_id = (int) $_POST['template_kit_id'];
		$template_id     = (int) $_POST['template_id'];
		try {
			
			require_once('class-events-records.php');
			$ss_RecoderApi=new RecoderApi();
			$template_kit_data_ss=$ss_RecoderApi->get_installed_template_ss_kit($template_kit_id);
			$template_data_ss=$this->get_template_data_ss($template_kit_id,$template_id);
			$json_data_template=json_decode( file_get_contents( $template_data_ss ), true );
			$template_data_to_return = $template_data_ss['template_json'];
			$source = \Elementor\Plugin::$instance->templates_manager->get_source( 'local' );
			$impoter_ss_result = $source->import_template( basename( $template_data_ss ), $template_data_ss );
			
			if(is_wp_error( $impoter_ss_result ) ){
				$result=[
					'status'=>false,
					'message'=>'Failed to import template: ' . esc_html( $impoter_ss_result->get_error_message() ),
				];
			}	
			
			if ( $impoter_ss_result[0] && $impoter_ss_result[0]['template_id'] ) {
				$imported_ss_template_id = $impoter_ss_result[0]['template_id'];
				$ssrecord=[
					'type'=>'import',
					'action'=>'import_json'.$template_kit_id,
					'template_id'=>$template_id,
					'post_id'=>$imported_ss_template_id,
				];
				$rr=SrmehranApi::$objRecoder->recordSmrhanEvent($ssrecord);
				
			if ( $json_data_template['metadata'] && ! empty( $json_data_template['metadata']['elementor_pro_conditions'] ) ) {
				update_post_meta( $imported_ss_template_id, '_elementor_conditions', $json_data_template['metadata']['elementor_pro_conditions'] );
			}
			if ( $json_data_template['metadata'] && ! empty( $json_data_template['metadata']['wp_page_template'] ) ) {
				// If there is a page template set we keep it the same here
				update_post_meta( $imported_ss_template_id, '_wp_page_template', $json_data_template['metadata']['wp_page_template'] );
			}
				
					update_post_meta( $imported_ss_template_id, 'srmehranclub_ss_source_kit', $template_kit_id );
					update_post_meta( $imported_ss_template_id, 'srmehranclub_ss_source_index', $template_id );
			}
			
			$imported__sss_ff=[];
			if(isset($_POST['installBy_ss'])){
				// we have to return additional JSON data so Elementor can insert these widgets on the page.
				\Elementor\Plugin::$instance->editor->set_edit_mode( true );
				$db      = \Elementor\Plugin::$instance->db;
				$content = $db->get_builder($imported_ss_template_id); 
				if ( ! empty( $content ) ) {
					$content = \Elementor\Plugin::$instance->db->iterate_data( $content, function ( $element ) {
						$element['id'] = \Elementor\Utils::generate_random_string();

						return $element;
					} );
				} 
				
				
				$imported__sss_ff['content'] = $content;
			}
			
			
			$result=[
					'status'=>true,
					'template_data'=>$imported_ss_template_id,
					'urledit'=>'post.php?post='.$imported_ss_template_id.'&action=elementor',
					'imported__sss_ff'=>$imported__sss_ff,
				];
		}
		 catch ( \Exception $e ) {
			 $result=[
					'status'=>$_POST,
					'message'=>$e->getMessage(),
				];
		 }
		
		
		echo json_encode($result);
			die;
	}
	
	public function get_import_free_Blocks(){
		
		if(isset($_POST['blocks_id']) && $_POST['blockstype']='Free_Blocks'){
			$info=SRMEHRAN_Templtes::$api_handel->sr_get_ss_user_info();
			$this->limitloader->limitsBulider();
			$getprodcutbyId=[
			'action'=>'getprodcutbyId',
			'pid'=>$_POST['blocks_id'],
			'type'=>'Free_kits',
			'userId'=>$info['username_ss'],
			];
			$getprodcutbyIdHandel=SRMEHRAN_Templtes::$api_handel->mehran_request_ajax('https://srmehranclub.com/',$getprodcutbyId);
			$getprodcutbyIdHandel=json_decode($getprodcutbyIdHandel);
		
			if($getprodcutbyIdHandel->status=='success'){
				$data=$getprodcutbyIdHandel->data[0];
				// Core WP image handling classes:
			require_once( ABSPATH . '/wp-admin/includes/file.php' );
			require_once( ABSPATH . '/wp-admin/includes/media.php' );
			require_once( ABSPATH . '/wp-admin/includes/image.php' );
				$temporary_zip_path = wp_tempnam( 'ss-' .$_POST['blocks_id']);
				
			$dresponse  = wp_safe_remote_get($data->download_link, array(
				'timeout'  => 60,
				'stream'   => true,
				'filename' => $temporary_zip_path
			) );
			
			// If we failed to download return an error
			if ( is_wp_error( $dresponse ) ) {
				$result=[
					'status'=>false,
					'message'=>$dresponse->get_error_message(),
				];
			}
			if(isset($_POST['instellByPopup'])){
				$getBloacksResponse=parent::BlocksInstallByPop($_POST['blocks_id'],$temporary_zip_path);
			$result=[
					'status'=>true,
					'data'=>$getBloacksResponse,
					'message'=>'successfully',
				];
			}else{
				$getBloacksResponse=parent::BlocksInstall($_POST['blocks_id'],$temporary_zip_path);
			$result=[
					'status'=>true,
					'data'=>$getBloacksResponse,
					'message'=>'successfully',
				];
			}
			
			
			
			}else{
				$result=[
					'status'=>false,
					'message'=>'0 record found55',
				];
			}
			
		}else{
			$result=[
					'status'=>false,
					'message'=>'0 record found444',
				];
		}
		
			
			
		echo json_encode($result);
			die;
	}
	
	
	public function load_ss_Template(){
		$data=SRMEHRAN_Templtes::$template_ui->get_installed_SRMEHRAN_Templtes_kits();
		if(count($data)>0){
			$result=[
					'status'=>true,
					'data'=>$data,
					'total'=>count($data),
					'message'=>count($data).' record found',
				];
		}else{
			$result=[
					'status'=>false,
					'data'=>$data,
					'total'=>count($data),
					'message'=>'0 record found',
				];
		}
		
		echo json_encode($result);
			die;
	}
	
	public function load_ss_premiumkits(){
		  
		$getTemplate=[
			'action'=>'GetCatgoaires',
			'type'=>'1'
			];
			
			$getTemplateCatgories=SRMEHRAN_Templtes::$api_handel->mehran_request_ajax('https://srmehranclub.com/',$getTemplate);
			$getprodcut=[
			'action'=>'GetProducts',
			'main_cat_id'=>'1',
			'price_type'=>'2',
			'start_from'=>$_POST['min'],
			'limit'=>$_POST['max'],
			];
			
			if($_POST['catId']!='all'){
				$getprodcut['sub_cat_id']=$_POST['catId'];
				$iscatory=$_POST['catId'];
			}else{
				$iscatory='all';
			}
			
			if($_POST['getBybrands']!=''){
				$getprodcut['brand_id']=$_POST['getBybrands'];
			}
			
		
			
			if(!empty($_POST['search'])){
				$getprodcut['q']=$_POST['search'];
			}
			
			$getinstall=SRMEHRAN_Templtes::$template_ui->getAlreadyInstalled('PremiumTemplate');
			
			
			$getProdcutApi=SRMEHRAN_Templtes::$api_handel->mehran_request_ajax('https://srmehranclub.com/',$getprodcut);
			
			$GetAllBrands=[
						'1'=>'ESSENTIAL ADDONS',
						'2'=>'WOOLENTOR PRO',
						'3'=>'HAPPY ELEMENTOR',
						'4'=>'PIOTNET ADDONS',
						'5'=>'ADDONS ELEMENTOR ',
						'6'=>'ANYWHERE ELEMENTOR',
						'7'=>'THE PLUS ADDONS',
						'8'=>'ULTIMATE ADDONS',
						'9'=>'WPKIT FOR ELEMENTOR',
						'10'=>'ASTRA TEMPLATES',
						'11'=>'SITEOCEANWP TEMPLATES',
						'12'=>'ENVATO TEMPLATES',
						'13'=>'TEMPLATEMONSTER TEMPLATES',
						'14'=>'PORTO TEMPLATES',
						'16'=>'SRMEHRANCLUB',
						'17'=>'MISCELLANEOUS BRAND',
						'18'=>'ELEMENTOR PRO',
						'19'=>'MASTER ADDONS',
						'20'=>'PRIME SLIDER',
						'21'=>'HT MEGA',
						'22'=>'CROCOBLOCK',
						'23'=>'THE PLUS ADD-ONS',
						'24'=>'POWERPACK',
						'25'=>'UNLIMITED ELEMENTS',
						'26'=>'ELEMENT PACK',
						'27'=>'PREMIUM ADD-ONS'
											];
			
			
			$result=[
					'status'=>true,
					'getTemplateCatgories'=>$getTemplateCatgories,
					'GetAllBrands'=>$GetAllBrands,
					'getProdcutApi'=>$getProdcutApi,
					'getinstall'=>$getinstall,
					'mincoun'=>$_POST['min'],
					'iscatory'=>$iscatory,
					'message'=>'record found',
				];
		
		 
			echo json_encode($result);
			die;
	}
	
	
	public function load_ss_freekits(){
		
		$getTemplate=[
			'action'=>'GetCatgoaires',
			'type'=>'1'
			];
			
			$getTemplateCatgories=SRMEHRAN_Templtes::$api_handel->mehran_request_ajax('https://srmehranclub.com/',$getTemplate);



				$free_kits=[
			'action'=>'GetProducts',
			'main_cat_id'=>'1',
			'price_type'=>'1',
			'start_from'=>$_POST['min'],
			'limit'=>$_POST['max'],
			];
			
			if($_POST['catId']!='all'){
				$free_kits['sub_cat_id']=$_POST['catId'];
			}
			
			if(!empty($_POST['search'])){
				$free_kits['q']=$_POST['search'];
			}
			
			
			if($_POST['getBybrands']!='all'){
				$free_kits['brand_id']=$_POST['getBybrands'];
			}
			
			$GetAllBrands=[
						'1'=>'ESSENTIAL ADDONS',
						'2'=>'WOOLENTOR PRO',
						'3'=>'HAPPY ELEMENTOR',
						'4'=>'PIOTNET ADDONS',
						'5'=>'ADDONS ELEMENTOR ',
						'6'=>'ANYWHERE ELEMENTOR',
						'7'=>'THE PLUS ADDONS',
						'8'=>'ULTIMATE ADDONS',
						'9'=>'WPKIT FOR ELEMENTOR',
						'10'=>'ASTRA TEMPLATES',
						'11'=>'SITEOCEANWP TEMPLATES',
						'12'=>'ENVATO TEMPLATES',
						'13'=>'TEMPLATEMONSTER TEMPLATES',
						'14'=>'PORTO TEMPLATES',
						'16'=>'SRMEHRANCLUB',
						'17'=>'MISCELLANEOUS BRAND',
						'18'=>'ELEMENTOR PRO',
						'19'=>'MASTER ADDONS',
						'20'=>'PRIME SLIDER',
						'21'=>'HT MEGA',
						'22'=>'CROCOBLOCK',
						'23'=>'THE PLUS ADD-ONS',
						'24'=>'POWERPACK',
						'25'=>'UNLIMITED ELEMENTS',
						'26'=>'ELEMENT PACK',
						'27'=>'PREMIUM ADD-ONS'
											];
			
			
			
			
			$getinstall=SRMEHRAN_Templtes::$template_ui->getAlreadyInstalled('Free_kits');
			$free_kits_Api=SRMEHRAN_Templtes::$api_handel->mehran_request_ajax('https://srmehranclub.com/',$free_kits);
			$result=[
					'status'=>true,
					'getTemplateCatgories'=>$getTemplateCatgories,
					'getProdcutApi'=>$free_kits_Api,
					'GetAllBrands'=>$GetAllBrands,
					'getinstall'=>$getinstall,
					'message'=>'record found',
				];
		
		
			echo json_encode($result);
			die;
	}
	
	
	public function load_ss_free_blocks(){
		require_once(SRMEHRAN_Templtes::$template_site_info->plugin_path.'templates/header.php');
			if($_POST['catId']!='all'){
				
				$free_blocksprodcut=[
			'action'=>'GetProducts',
			'main_cat_id'=>'2',
			'sub_cat_id'=>$_POST['catId'],
			'start_from'=>$_POST['min'],
			'limit'=>$_POST['max'],
			];
			
			if($_POST['p_ssfillter']!='all'){
				$free_blocksprodcut['price_type']=$_POST['p_ssfillter'];
			}
			
			if(!empty($_POST['search'])){
				$free_blocksprodcut['q']=$_POST['search'];
			}
			 $getfree_blocksProdcutApi=SRMEHRAN_Templtes::$api_handel->mehran_request_ajax('https://srmehranclub.com/',$free_blocksprodcut);
				$result=[
					'status'=>'by_ss_Id',
					'mincoun'=>$_POST['min'],
					'ss_data'=>$getfree_blocksProdcutApi
				];
				echo json_encode($result);
				die;
			}else{
				$getblocks=[
			'action'=>'GetCatgoaires',
			'type'=>'2'
			];
			echo $getblocksCatgories=SRMEHRAN_Templtes::$api_handel->mehran_request_ajax('https://srmehranclub.com/',$getblocks);
			die;
			}
			
			
	}
	
	public function load_ss_Template_ById(){
		$dataId=$_POST['dataId'];
		$data=SRMEHRAN_Templtes::$template_ui->getInsttaledKitbyId($dataId);
		if(count($data['templates'])>0){
			$result=[
					'status'=>true,
					'data'=>$data,
					'total'=>count($data['templates']),
					'message'=>count($data['templates']).' record found',
				];
		}else{
			$result=[
					'status'=>false,
					'data'=>$data,
					'message'=>'0 record found',
				];
			
		}
		
				echo json_encode($result);
			die;
		
	}
	
}



