	
	<h3 class="serverinfo_h3">Server environment</h4>
	
	<?php 
	
	function parsePHPModules() {
ob_start();
phpinfo();
$s = ob_get_contents();
ob_end_clean();

$s = strip_tags($s,'<h2><th><td>');
$s = preg_replace('/<th[^>]*>([^<]+)<\/th>/',"<info>\\1</info>",$s);
$s = preg_replace('/<td[^>]*>([^<]+)<\/td>/',"<info>\\1</info>",$s);
$vTmp = preg_split('/(<h2>[^<]+<\/h2>)/',$s,-1,PREG_SPLIT_DELIM_CAPTURE);
$vModules = array();
for ($i=1;$i<count($vTmp);$i++) {
  if (preg_match('/<h2>([^<]+)<\/h2>/',$vTmp[$i],$vMat)) {
   $vName = trim($vMat[1]);
   $vTmp2 = explode("\n",$vTmp[$i+1]);
   foreach ($vTmp2 AS $vOne) {
    $vPat = '<info>([^<]+)<\/info>';
    $vPat3 = "/$vPat\s*$vPat\s*$vPat/";
    $vPat2 = "/$vPat\s*$vPat/";
    if (preg_match($vPat3,$vOne,$vMat)) { // 3cols
     $vModules[$vName][trim($vMat[1])] = array(trim($vMat[2]),trim($vMat[3]));
    } elseif (preg_match($vPat2,$vOne,$vMat)) { // 2cols
     $vModules[$vName][trim($vMat[1])] = trim($vMat[2]);
    }
   }
  }
}
return $vModules;
}
	?>
	
	<div class="table-responsive1" style="overflow-x:auto;">
		<table style="width:100%; border-collapse: collapse;" class="w3-striped">
		<?php 
		$info=parsePHPModules();

		?>
			<tr>
				<td>PHP Version</td>
				<td><?=$info['Core']['PHP Version'] ?></td>
			</tr>
			<tr>
				<td>allow_url_fopen</td>
				<td><?=$info['Core']['allow_url_fopen'][0] ?></td>
			</tr>
			<tr>
				<td>file_uploads</td>
				<td><?=$info['Core']['file_uploads'][0] ?></td>
			</tr>
			<tr>
				<td>hash support</td>
				<td>✔️</td>
			</tr>
			<tr>
				<td>json support</td>
				<td>✔️</td>
			</tr>
			<tr>
				<td>json version</td>
				<td><?=$info['json']['json version'] ?></td>
			</tr>
			<tr>
				<td>Mysqli Support</td>
				<td><?=($info['mysqli']['MysqlI Support']=='enabled')?'<p class="workibg">✔️</p>':'<p class="eror">error</p>'?> </td>
			</tr>
			
			<tr>
				<td>cURL support</td>
				<td><?=($info['curl']['cURL support']=='enabled')?'<p class="workibg">✔️</p>':'<p class="eror">error</p>' ?></td>
			</tr>
			<tr>
				<td>cURL Information</td>
				<td><?=$info['curl']['cURL Information'] ?></td>
			</tr>
			<tr>
				<td>Post Max</td>
				<td><?=$info['Core']['post_max_size'][0] ?></td>
			</tr>
			<tr>
				<td>Max Input Time</td>
				<td><?=$info['Core']['max_input_time'][0] ?></td>
			</tr>
			<tr>
				<td>Memory Limit</td>
				<td><?=$info['Core']['memory_limit'][0] ?></td>
			</tr>
			<tr>
				<td>Max Input Vars</td>
				<td><?=$info['Core']['max_input_vars'][0] ?></td>
			</tr>
			
		</table>
</div>